SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'topOfTheStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:32'!
initialize 

	super initialize.
	topOfTheStack := OOStackBase new.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:17'!
isEmpty
	
	^ topOfTheStack isEmpty .! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:39'!
pop
	
	| toBePop |
	
	toBePop := topOfTheStack .
	topOfTheStack := topOfTheStack pop  .
	^ toBePop value ! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:32'!
push: anElement
	
	topOfTheStack := OOStackElement new push: anElement onTopOf:  self.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:47'!
size

	^ topOfTheStack height! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:39'!
top 

	^ topOfTheStack value ! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:18'!
topOfTheStack 

	^ topOfTheStack ! !

Object subclass: #OOStackBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackBase methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:46'!
height
	
	^ 0! !

!OOStackBase methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 19:25'!
isEmpty 

	^ true! !

!OOStackBase methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:02'!
pop
	self error: OOStack stackEmptyErrorDescription! !

!OOStackBase methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:39'!
value
	self error: OOStack stackEmptyErrorDescription! !

Object subclass: #OOStackElement
	instanceVariableNames: 'element previousElement size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:47'!
height

	^ size! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 19:27'!
isEmpty
	
	^ false! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 19:34'!
pop
	
	^ previousElement ! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:18'!
push: anElement  onTopOf: aStack
	
	element := anElement .
	previousElement := aStack topOfTheStack .
	size := (aStack size) + 1! !

!OOStackElement methodsFor: 'as yet unclassified' stamp: 'TomiRodriguez 5/7/2013 20:39'!
value

	^ element ! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
